diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/rs6000.cc gcc-15.1.0/gcc/config/rs6000/rs6000.cc
--- gcc-15.1.0.orig/gcc/config/rs6000/rs6000.cc	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/config/rs6000/rs6000.cc	2025-06-10 09:18:42.000241751 +0300
@@ -1366,7 +1366,11 @@
 #define TARGET_HAVE_TLS HAVE_AS_TLS
 
 #undef TARGET_CANNOT_FORCE_CONST_MEM
+#ifdef TARGET_BASEREL
+#define TARGET_CANNOT_FORCE_CONST_MEM rs6000_cannot_force_const_mem_baserel
+#else
 #define TARGET_CANNOT_FORCE_CONST_MEM rs6000_cannot_force_const_mem
+#endif
 
 #undef TARGET_DELEGITIMIZE_ADDRESS
 #define TARGET_DELEGITIMIZE_ADDRESS rs6000_delegitimize_address
@@ -8247,6 +8251,11 @@
 #if TARGET_ELF
   rtx sym_ref;
 
+#ifdef TARGET_BASEREL
+  if (TARGET_BASEREL)
+    return 0;
+#endif
+
   if (rs6000_sdata == SDATA_NONE || rs6000_sdata == SDATA_DATA)
     return 0;
 
@@ -9169,6 +9178,14 @@
 	return rs6000_legitimize_tls_address (x, model);
     }
 
+#ifdef TARGET_BASEREL
+  if (TARGET_BASEREL &&
+      morphos_baserel_operand(x))
+    {
+      return morphos_legitimize_baserel_address(x);
+    }
+#endif
+
   extra = 0;
   switch (mode)
     {
@@ -9839,6 +9856,14 @@
   return TARGET_ELF && tls_referenced_p (x);
 }
 
+#ifdef TARGET_BASEREL
+static bool
+rs6000_cannot_force_const_mem_baserel (machine_mode mode ATTRIBUTE_UNUSED, rtx x)
+{
+  return rs6000_cannot_force_const_mem((machine_mode)0, x) || morphos_baserel_referenced_p(x);
+}
+#endif
+
 /* Return true iff the given SYMBOL_REF refers to a constant pool entry
    that we have put in the TOC, or for cmodel=medium, if the SYMBOL_REF
    can be addressed relative to the toc pointer.  */
@@ -11032,6 +11057,25 @@
       operands[1] = tmp;
     }
 
+#ifdef TARGET_BASEREL
+  if (TARGET_BASEREL &&
+      morphos_baserel_operand (operands[1]))
+    {
+      if (can_create_pseudo_p())
+      {
+        operands[1] = morphos_legitimize_baserel_address (operands[1]);
+      }
+      else if (GET_CODE(operands[0]) == REG)
+      {
+        operands[1] = morphos_legitimize_baserel_address_in_place (operands[1], operands[0]);
+      }
+      else
+      {
+        gcc_assert(0);
+      }
+    }
+#endif
+
   /* 128-bit constant floating-point values on Darwin should really be loaded
      as two parts.  However, this premature splitting is a problem when DFmode
      values can go into Altivec registers.  */
@@ -11291,7 +11335,15 @@
 					target, operands[1]));
 	      return;
 	    }
-
+#ifdef TARGET_BASEREL
+	  if (TARGET_BASEREL &&
+         morphos_baserel_operand(operands[1]))
+	    {
+         emit_insn (gen_elf_base_high (target, gen_rtx_REG (Pmode, 13), operands[1]));
+         emit_insn (gen_elf_base_low (operands[0], target, operands[1]));
+         return;
+       }
+#endif
 	  emit_insn (gen_elf_high (target, operands[1]));
 	  emit_insn (gen_elf_low (operands[0], target, operands[1]));
 	  return;
@@ -14277,6 +14329,11 @@
 							   UNITS_PER_WORD),
 				  0));
 
+#ifdef TARGET_BASEREL
+	   if (TARGET_BASEREL && morphos_baserel_operand(x))
+        fprintf (file, "@%s", DATA_DATA_RELOC);
+      else
+#endif
 	  if (small_data_operand (x, GET_MODE (x)))
 	    fprintf (file, "@%s(%s)", SMALL_DATA_RELOC,
 		     reg_names[SMALL_DATA_REG]);
@@ -14533,6 +14590,11 @@
 						 XEXP (XEXP (x, 0), 0), 8));
 	  else
 	    output_address (mode, XEXP (adjust_address_nv (x, SImode, 8), 0));
+#ifdef TARGET_BASEREL
+	   if (TARGET_BASEREL && morphos_baserel_operand(x))
+        fprintf (file, "@%s", DATA_DATA_RELOC);
+      else
+#endif
 	  if (small_data_operand (x, GET_MODE (x)))
 	    fprintf (file, "@%s(%s)", SMALL_DATA_RELOC,
 		     reg_names[SMALL_DATA_REG]);
@@ -14587,6 +14649,11 @@
 						 XEXP (XEXP (x, 0), 0), 12));
 	  else
 	    output_address (mode, XEXP (adjust_address_nv (x, SImode, 12), 0));
+#ifdef TARGET_BASEREL
+	   if (TARGET_BASEREL && morphos_baserel_operand(x))
+        fprintf (file, "@%s", DATA_DATA_RELOC);
+      else
+#endif
 	  if (small_data_operand (x, GET_MODE (x)))
 	    fprintf (file, "@%s(%s)", SMALL_DATA_RELOC,
 		     reg_names[SMALL_DATA_REG]);
@@ -14718,6 +14785,11 @@
 	   || GET_CODE (x) == LABEL_REF)
     {
       output_addr_const (file, x);
+#ifdef TARGET_BASEREL
+	   if (TARGET_BASEREL && morphos_baserel_operand(x))
+        fprintf (file, "@%s", DATA_DATA_RELOC);
+      else
+#endif
       if (small_data_operand (x, GET_MODE (x)))
 	fprintf (file, "@%s(%s)", SMALL_DATA_RELOC,
 		 reg_names[SMALL_DATA_REG]);
@@ -14757,6 +14829,11 @@
 	   && CONSTANT_P (XEXP (x, 1)))
     {
       output_addr_const (file, XEXP (x, 1));
+#ifdef TARGET_BASEREL
+	   if (TARGET_BASEREL && morphos_baserel_operand(x))
+	      fprintf (file, "@%s@l(%s)", DATA_DATA_RELOC, reg_names[ REGNO (XEXP (x, 0)) ]);
+	   else
+#endif
       fprintf (file, "@l(%s)", reg_names[ REGNO (XEXP (x, 0)) ]);
     }
 #endif
@@ -14881,6 +14958,22 @@
   return default_assemble_integer (x, size, aligned_p);
 }
 
+#ifdef TARGET_USES_MORPHOS_OPT
+
+/* Implement `TARGET_ADDR_SPACE_ZERO_ADDRESS_VALID'. Fixes loading
+   SysBase from address 4. */
+
+static bool
+rs6000_addr_space_zero_address_valid (addr_space_t)
+{
+  return true;
+}
+
+#undef  TARGET_ADDR_SPACE_ZERO_ADDRESS_VALID
+#define TARGET_ADDR_SPACE_ZERO_ADDRESS_VALID rs6000_addr_space_zero_address_valid
+
+#endif /* TARGET_USES_MORPHOS_OPT */
+
 /* Return a template string for assembly to emit when making an
    external call.  FUNOP is the call mem argument operand number.  */
 
@@ -20843,6 +20936,10 @@
     return default_elf_select_rtx_section (mode, x, align);
 }
 
+
+static int
+rs6000_elf_reloc_rw_mask (void);
+
 /* For a SYMBOL_REF, set generic flags and then perform some
    target-specific processing.
 
@@ -20869,6 +20966,36 @@
       memcpy (str + 1, XSTR (sym_ref, 0), len + 1);
       XSTR (sym_ref, 0) = ggc_alloc_string (str, len + 1);
     }
+
+#ifdef TARGET_BASEREL
+  if (TARGET_BASEREL)
+    {
+      rtx symbol = XEXP (rtl, 0);
+
+      if(TREE_CODE (decl) == VAR_DECL &&
+			!TREE_READONLY(decl) &&
+			GET_CODE (symbol) == SYMBOL_REF)
+        {
+          const char *name = DECL_SECTION_NAME (decl);
+          if (name == NULL || (strncmp(name, ".ctors", 6) != 0 && strncmp(name, ".dtors", 6) != 0))
+            {
+              switch (categorize_decl_for_section (decl, rs6000_elf_reloc_rw_mask()))
+                {
+                  case SECCAT_DATA:
+                  case SECCAT_SDATA:
+                  case SECCAT_TDATA:
+                  case SECCAT_BSS:
+                  case SECCAT_SBSS:
+                  case SECCAT_TBSS:
+                    SYMBOL_REF_FLAGS (symbol) |= SYMBOL_FLAG_MORPHOS_BASEREL;
+                    break;
+                  default:
+                    break;
+                }
+            }
+        }
+    }
+#endif
 }
 
 static inline bool
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/rs6000-internal.h gcc-15.1.0/gcc/config/rs6000/rs6000-internal.h
--- gcc-15.1.0.orig/gcc/config/rs6000/rs6000-internal.h	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/config/rs6000/rs6000-internal.h	2025-04-25 15:58:40.268619866 +0300
@@ -62,6 +62,11 @@
   int altivec_padding_size;	/* size of altivec alignment padding */
   HOST_WIDE_INT total_size;	/* total bytes allocated for stack */
   int savres_strategy;
+#ifdef TARGET_BASEREL
+  int baserel_save_p;		/* true if the baserel register needs to be saved */
+  int baserel_save_offset;	/* offset to save baserel register */
+  int baserel_size;		/* size of saved baserel register */
+#endif
 } rs6000_stack_t;
 
 
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/rs6000-logue.cc gcc-15.1.0/gcc/config/rs6000/rs6000-logue.cc
--- gcc-15.1.0.orig/gcc/config/rs6000/rs6000-logue.cc	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/config/rs6000/rs6000-logue.cc	2025-04-25 15:58:40.268619866 +0300
@@ -722,6 +722,18 @@
       && info->calls_p)
     info->rop_hash_size = 8;
 
+#ifdef TARGET_BASEREL
+  if (TARGET_BASEREL
+       && current_function_decl
+       && lookup_attribute ("saveds", TYPE_ATTRIBUTES (TREE_TYPE (current_function_decl))))
+  {
+    info->baserel_save_p = 1;
+    info->baserel_size = reg_size;
+    info->calls_p = 1;
+    df_set_regs_ever_live (13, true);
+  }
+#endif /* TARGET_BASEREL */
+
   /* Determine if we need to save the condition code registers.  */
   if (save_reg_p (CR2_REGNO)
       || save_reg_p (CR3_REGNO)
@@ -829,7 +841,12 @@
     case ABI_V4:
       info->fp_save_offset = -info->fp_size;
       info->gp_save_offset = info->fp_save_offset - info->gp_size;
+#ifdef TARGET_BASEREL
+      info->baserel_save_offset = info->gp_save_offset - info->baserel_size;
+      info->cr_save_offset      = info->baserel_save_offset - info->cr_size;
+#else
       info->cr_save_offset = info->gp_save_offset - info->cr_size;
+#endif
 
       if (TARGET_ALTIVEC_ABI)
 	{
@@ -865,6 +882,10 @@
 				  + info->vrsave_size,
 				  save_align);
 
+#ifdef TARGET_BASEREL
+  info->save_size += RS6000_ALIGN (info->baserel_size, save_align);
+#endif
+
   non_fixed_size = info->vars_size + info->parm_size + info->save_size;
 
   info->total_size = RS6000_ALIGN (non_fixed_size + info->fixed_size,
@@ -971,6 +992,11 @@
   if (info->cr_save_p)
     fprintf (stderr, "\tcr_save_p           = %5d\n", info->cr_save_p);
 
+#ifdef TARGET_BASEREL
+  if (info->baserel_save_p)
+    fprintf (stderr, "\tbaserel_save_p      = %5d\n", info->baserel_save_p);
+#endif
+
   if (info->vrsave_mask)
     fprintf (stderr, "\tvrsave_mask         = 0x%x\n", info->vrsave_mask);
 
@@ -1007,6 +1033,11 @@
   if (info->varargs_save_offset)
     fprintf (stderr, "\tvarargs_save_offset = %5d\n", info->varargs_save_offset);
 
+#ifdef TARGET_BASEREL
+  if (info->baserel_save_offset && TARGET_BASEREL)
+    fprintf (stderr, "\tbaserel_save_offset = %5d\n", info->baserel_save_offset);
+#endif
+
   if (info->total_size)
     fprintf (stderr, "\ttotal_size          = " HOST_WIDE_INT_PRINT_DEC"\n",
 	     info->total_size);
@@ -1033,6 +1064,11 @@
   if (info->vrsave_size)
     fprintf (stderr, "\tvrsave_size         = %5d\n", info->vrsave_size);
 
+#ifdef TARGET_BASEREL
+  if (info->baserel_size && TARGET_BASEREL)
+    fprintf (stderr, "\tbaserel_size        = %5d\n", info->baserel_size);
+#endif
+
   if (info->altivec_padding_size)
     fprintf (stderr, "\taltivec_padding_size= %5d\n",
 	     info->altivec_padding_size);
@@ -1147,6 +1183,16 @@
   else
     fntype = TREE_TYPE (TREE_TYPE (CALL_EXPR_FN (exp)));
 
+#ifdef TARGET_BASEREL
+  /* We can't do it if the calling function is baserel with saveds attribute.  */
+  if (TARGET_BASEREL
+      && current_function_decl
+      && lookup_attribute ("saveds", TYPE_ATTRIBUTES (TREE_TYPE (current_function_decl))))
+    {
+      return false;
+    }
+#endif
+
   /* We can't do it if the called function has more vector parameters
      than the current function; there's nowhere to put the VRsave code.  */
   if (TARGET_ALTIVEC_ABI
@@ -2720,6 +2766,12 @@
       || bitmap_bit_p (kill, LR_REGNO))
     bitmap_set_bit (components, 0);
 
+#ifdef TARGET_BASEREL
+  /* Always mark LR saving to occur before basic_block if "saveds" function */
+  if (TARGET_BASEREL && info->baserel_save_p)
+    bitmap_set_bit (components, 0);
+#endif
+
   /* The TOC save.  */
   if (bitmap_bit_p (in, TOC_REGNUM)
       || bitmap_bit_p (gen, TOC_REGNUM)
@@ -3281,6 +3333,22 @@
       emit_insn (gen_hashst (mem, reg0));
     }
 
+#ifdef TARGET_BASEREL
+  if (info->baserel_save_p && TARGET_BASEREL)
+    {
+      /* Store r13 */
+      rtx addr, reg, mem;
+      rtx frame_ptr_rtx = gen_rtx_REG (Pmode, 1);
+
+      addr = gen_rtx_PLUS (Pmode, frame_reg_rtx,
+               GEN_INT (info->baserel_save_offset + frame_off));
+      mem = gen_frame_mem (reg_mode, addr);
+
+      reg = gen_rtx_REG (reg_mode, 13);
+      insn = emit_move_insn (mem, reg);
+      rs6000_frame_related (insn, sp_reg_rtx, info->total_size, NULL_RTX, NULL_RTX);
+    }
+#endif
   /* If we need to save CR, put it into r12 or r11.  Choose r12 except when
      r12 will be needed by out-of-line gpr save.  */
   if (DEFAULT_ABI == ABI_AIX
@@ -3873,6 +3941,18 @@
 	emit_move_insn (lr, gen_rtx_REG (Pmode, 0));
     }
 #endif
+#ifdef TARGET_BASEREL
+  if (info->baserel_save_p && TARGET_BASEREL)
+    {
+      /* Call __restore_r13 */
+      rtx restore_r13_ref = gen_rtx_SYMBOL_REF (Pmode, "__restore_r13");
+      SYMBOL_REF_FLAGS (restore_r13_ref) |= (SYMBOL_FLAG_LOCAL | SYMBOL_FLAG_FUNCTION);
+
+      emit_call_insn (gen_call (gen_rtx_MEM (SImode, restore_r13_ref), const0_rtx, const0_rtx));
+
+      emit_insn (gen_blockage ());
+    }
+#endif
 
   /* If we need to, save the TOC register after doing the stack setup.
      Do not emit eh frame info for this save.  The unwinder wants info,
@@ -3935,6 +4015,10 @@
 	  fprintf (file, "\t.extern %s\n", name);
 	}
     }
+#ifdef TARGET_BASEREL
+  if (info->baserel_save_p && TARGET_BASEREL)
+    fprintf (file, "\t.extern __restore_r13\n");
+#endif
 }
 
 /* Write function prologue.  */
@@ -4880,6 +4964,24 @@
 	}
     }
 
+#ifdef TARGET_BASEREL
+  if (info->baserel_save_p && TARGET_BASEREL)
+    {
+      rtx addr, mem, reg;
+
+      /* Restore r13 */
+      addr = gen_rtx_PLUS (Pmode, frame_reg_rtx,
+               GEN_INT (info->baserel_save_offset + frame_off));
+      mem = gen_frame_mem (reg_mode, addr);
+
+      reg = gen_rtx_REG (reg_mode, 13);
+      emit_move_insn (reg, mem);
+
+      /* Mark register as used.  */
+      emit_insn (gen_rtx_USE (VOIDmode, reg));
+    }
+#endif
+
   /* Restore GPRs.  This is done as a PARALLEL if we are using
      the load-multiple instructions.  */
   if (!restoring_GPRs_inline)
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/t-morphos gcc-15.1.0/gcc/config/rs6000/t-morphos
--- gcc-15.1.0.orig/gcc/config/rs6000/t-morphos	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/gcc/config/rs6000/t-morphos	2025-04-25 15:58:40.268619866 +0300
@@ -0,0 +1,34 @@
+MULTILIB_OPTIONS      = mbaserel32 mclib=libnix
+MULTILIB_DIRNAMES     = libb32 libnix
+MULTILIB_MATCHES      = mbaserel32=mresident32
+MULTILIB_EXTRA_OPTS   = mstrict-align
+
+EXTRA_MULTILIB_PARTS  = crtbegin$(objext) crtend$(objext) ecrti$(objext) ecrtn$(objext) ncrti$(objext) ncrtn$(objext)
+
+LIBGCC                = stmp-multilib
+INSTALL_LIBGCC        = install-multilib
+
+TARGET_LIBGCC2_CFLAGS = 
+CRTSTUFF_T_CFLAGS     = -msdata=none -mstrict-align
+
+# We want fine grained libraries, so use the new code to build the
+# floating point emulation libraries.
+FPBIT = fp-bit.c
+DPBIT = dp-bit.c
+
+# Extra
+morphos.o: $(srcdir)/config/rs6000/morphos.c $(srcdir)/config/rs6000/morphos-protos.h $(CONFIG_H)
+	$(COMPILE) $<
+
+NATIVE_SYSTEM_HEADER_DIR = /include
+
+# Don't run fixinclude
+STMP_FIXINC = stmp-sdefixinc
+stmp-sdefixinc: gsyslimits.h
+	rm -rf include; mkdir include
+	chmod a+rx include
+	rm -f include/syslimits.h
+	cp $(srcdir)/gsyslimits.h include/syslimits.h
+	chmod a+r include/syslimits.h
+	$(STAMP) stmp-sdefixinc
+
diff -ruN gcc-15.1.0.orig/gcc/config.gcc gcc-15.1.0/gcc/config.gcc
--- gcc-15.1.0.orig/gcc/config.gcc	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/config.gcc	2025-04-25 15:58:40.268619866 +0300
@@ -3060,6 +3060,15 @@
 	extra_options="${extra_options} rs6000/sysv4.opt rs6000/linux64.opt"
 	tmake_file="${tmake_file} rs6000/t-fprules rs6000/t-rtems rs6000/t-ppccomm"
 	;;
+powerpc-*-morphos*)
+	tm_file="${tm_file} elfos.h usegas.h rs6000/sysv4.h rs6000/morphos.h rs6000/morphos-stdint.h"
+	tm_p_file="${tm_p_file} rs6000/morphos-protos.h"
+	extra_options="${extra_options} rs6000/sysv4.opt rs6000/morphos.opt"
+	extra_parts="crtbegin.o crtend.o"
+	tmake_file="${tmake_file} t-dfprules rs6000/t-fprules rs6000/t-fprules-fpbit rs6000/t-ppcgas rs6000/t-ppcos rs6000/t-ppccomm rs6000/t-morphos"
+	extra_objs="${extra_objs} morphos.o"
+	use_gcc_tgmath=yes
+	;;
 powerpc*-*-linux*)
 	tm_file="${tm_file} elfos.h gnu-user.h linux.h freebsd-spec.h rs6000/sysv4.h"
 	extra_options="${extra_options} rs6000/sysv4.opt"
diff -ruN gcc-15.1.0.orig/gcc/config.host gcc-15.1.0/gcc/config.host
--- gcc-15.1.0.orig/gcc/config.host	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/config.host	2025-04-25 15:58:40.272619898 +0300
@@ -260,6 +260,10 @@
     out_host_hook_obj="${out_host_hook_obj} host-ppc64-darwin.o"
     host_xmake_file="${host_xmake_file} rs6000/x-darwin64"
     ;;
+  p*pc-*-morphos*)
+    prefix=/gg
+    local_prefix=/gg
+    ;;
   rs6000-ibm-aix* | powerpc-ibm-aix*)
     host_xmake_file="${host_xmake_file} rs6000/x-aix"
     ;;
diff -ruN gcc-15.1.0.orig/gcc/configure.ac gcc-15.1.0/gcc/configure.ac
--- gcc-15.1.0.orig/gcc/configure.ac	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/configure.ac	2025-04-25 15:58:40.272619898 +0300
@@ -1619,6 +1619,10 @@
   # just force it.
   ac_cv_func_vfork_works=yes
   ;;
+*-*-*morphos*)
+  # Under MorphOS, don't try to use fork.
+  ac_cv_func_fork_works=no
+  ;;
 esac
 AC_FUNC_FORK
 
@@ -2090,7 +2094,7 @@
     target_thread_file='single'
     ;;
   aix | dce | lynx | mipssde | posix | rtems | \
-  single | tpf | vxworks | win32 | mcf)
+  single | tpf | vxworks | win32 | mcf | morphos)
     target_thread_file=${enable_threads}
     ;;
   *)
diff -ruN gcc-15.1.0.orig/gcc/coretypes.h gcc-15.1.0/gcc/coretypes.h
--- gcc-15.1.0.orig/gcc/coretypes.h	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/coretypes.h	2025-04-25 15:58:40.276619928 +0300
@@ -375,11 +375,13 @@
    in target.h.  */
 typedef int reg_class_t;
 
+#ifdef __cplusplus
 class rtl_opt_pass;
 
 namespace gcc {
   class context;
 }
+#endif
 
 typedef std::pair <tree, tree> tree_pair;
 typedef std::pair <const char *, int> string_int_pair;
diff -ruN gcc-15.1.0.orig/gcc/cppdefault.cc gcc-15.1.0/gcc/cppdefault.cc
--- gcc-15.1.0.orig/gcc/cppdefault.cc	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/cppdefault.cc	2025-04-25 15:58:40.276619928 +0300
@@ -40,6 +40,10 @@
 = INCLUDE_DEFAULTS;
 #else
 = {
+#ifdef OSINCLUDE_DIR
+    { OSINCLUDE_DIR, NATIVE_SYSTEM_HEADER_COMPONENT, 0, 0, 1, 2 },
+    { OSINCLUDE_DIR, NATIVE_SYSTEM_HEADER_COMPONENT, 0, 0, 1, 0 },
+#endif
 #ifdef GPLUSPLUS_INCLUDE_DIR
     /* Pick up GNU C++ generic include files.  */
     { GPLUSPLUS_INCLUDE_DIR, "G++", 1, 1,
diff -ruN gcc-15.1.0.orig/gcc/gcov-io.h gcc-15.1.0/gcc/gcov-io.h
--- gcc-15.1.0.orig/gcc/gcov-io.h	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/gcov-io.h	2025-04-25 15:58:40.276619928 +0300
@@ -201,7 +201,7 @@
 #endif
 #endif
 
-#if defined (HOST_HAS_F_SETLKW)
+#if defined (HOST_HAS_F_SETLKW) && !defined (TARGET_USES_MORPHOS_OPT)
 #define GCOV_LOCKED 1
 #else
 #define GCOV_LOCKED 0
diff -ruN gcc-15.1.0.orig/gcc/ginclude/stddef.h gcc-15.1.0/gcc/ginclude/stddef.h
--- gcc-15.1.0.orig/gcc/ginclude/stddef.h	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/ginclude/stddef.h	2025-04-25 15:58:40.276619928 +0300
@@ -46,15 +46,21 @@
 /* This avoids lossage on SunOS but only if stdtypes.h comes first.
    There's no way to win with the other order!  Sun lossage.  */
 
-#if defined(__NetBSD__)
+/* On 4.3bsd-net2, make sure ansi.h is included, so we have
+   one less case to deal with in the following.  */
+#if defined (__BSD_NET2__) || defined (____386BSD____) || (defined (__FreeBSD__) && (__FreeBSD__ < 5)) || defined(__NetBSD__)
 #include <machine/ansi.h>
 #endif
-
-#if defined (__FreeBSD__)
+/* On FreeBSD 5, machine/ansi.h does not exist anymore... */
+#if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
 #include <sys/_types.h>
 #endif
 
-#if defined(__NetBSD__)
+/* In 4.3bsd-net2, machine/ansi.h defines these symbols, which are
+   defined if the corresponding type is *not* defined.
+   FreeBSD-2.1 defines _MACHINE_ANSI_H_ instead of _ANSI_H_.
+   NetBSD defines _I386_ANSI_H_ and _X86_64_ANSI_H_ instead of _ANSI_H_ */
+#if defined(_ANSI_H_) || defined(_MACHINE_ANSI_H_) || defined(_X86_64_ANSI_H_)  || defined(_I386_ANSI_H_)
 #if !defined(_SIZE_T_) && !defined(_BSD_SIZE_T_)
 #define _SIZE_T
 #endif
@@ -81,7 +87,7 @@
 #undef _WCHAR_T_
 #undef _BSD_WCHAR_T_
 #endif
-#endif /* defined(__NetBSD__) */
+#endif /* defined(_ANSI_H_) || defined(_MACHINE_ANSI_H_) || defined(_X86_64_ANSI_H_) || defined(_I386_ANSI_H_) */
 
 /* Sequent's header files use _PTRDIFF_T_ in some conflicting way.
    Just ignore it.  */
@@ -214,11 +220,12 @@
 #define ___int_size_t_h
 #define _GCC_SIZE_T
 #define _SIZET_
-#if defined (__FreeBSD__) \
+#if (defined (__FreeBSD__) && (__FreeBSD__ >= 5)) \
   || defined(__DragonFly__) \
-  || defined(__FreeBSD_kernel__) \
-  || defined(__VMS__)
-/* __size_t is a typedef, must not trash it.  */
+  || defined(__FreeBSD_kernel__)
+/* __size_t is a typedef on FreeBSD 5, must not trash it. */
+#elif defined (__VMS__)
+/* __size_t is also a typedef on VMS.  */
 #else
 #define __size_t
 #endif
@@ -376,7 +383,11 @@
 #undef __need_wint_t
 #endif
 
-#if defined(__NetBSD__)
+/*  In 4.3bsd-net2, leave these undefined to indicate that size_t, etc.
+    are already defined.  */
+/*  BSD/OS 3.1 and FreeBSD [23].x require the MACHINE_ANSI_H check here.  */
+/*  NetBSD 5 requires the I386_ANSI_H and X86_64_ANSI_H checks here.  */
+#if defined(_ANSI_H_) || defined(_MACHINE_ANSI_H_) || defined(_X86_64_ANSI_H_) || defined(_I386_ANSI_H_)
 /*  The references to _GCC_PTRDIFF_T_, _GCC_SIZE_T_, and _GCC_WCHAR_T_
     are probably typos and should be removed before 2.8 is released.  */
 #ifdef _GCC_PTRDIFF_T_
@@ -404,7 +415,7 @@
 #undef _WCHAR_T_
 #undef _BSD_WCHAR_T_
 #endif
-#endif /* __NetBSD__ */
+#endif /* _ANSI_H_ || _MACHINE_ANSI_H_ || _X86_64_ANSI_H_ || _I386_ANSI_H_ */
 
 #endif /* __sys_stdtypes_h */
 
diff -ruN gcc-15.1.0.orig/libatomic/config/morphos/host-config.h gcc-15.1.0/libatomic/config/morphos/host-config.h
--- gcc-15.1.0.orig/libatomic/config/morphos/host-config.h	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/libatomic/config/morphos/host-config.h	2025-04-25 15:58:40.276619928 +0300
@@ -0,0 +1,55 @@
+/* Copyright (C) 2014-2019 Free Software Foundation, Inc.
+   Contributed by Kai Tietz <ktietz@redhat.com>.
+   Copyright (C) 2020 Harry Sintonen <sintonen@iki.fi>.
+
+   This file is part of the GNU Atomic Library (libatomic).
+
+   Libatomic is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   Libatomic is distributed in the hope that it will be useful, but WITHOUT ANY
+   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+   more details.
+
+   Under Section 7 of GPL version 3, you are granted additional
+   permissions described in the GCC Runtime Library Exception, version
+   3.1, as published by the Free Software Foundation.
+
+   You should have received a copy of the GNU General Public License and
+   a copy of the GCC Runtime Library Exception along with this program;
+   see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+   <http://www.gnu.org/licenses/>.  */
+
+/* Included after all more target-specific host-config.h.  */
+
+#ifndef protect_start_end
+# ifdef HAVE_ATTRIBUTE_VISIBILITY
+#  pragma GCC visibility push(hidden)
+# endif
+
+void libat_lock_1(void *ptr);
+void libat_unlock_1(void *ptr);
+
+static inline UWORD
+protect_start(void *ptr)
+{
+  libat_lock_1(ptr);
+  return 0;
+}
+
+static inline void
+protect_end(void *ptr, UWORD dummy UNUSED)
+{
+  libat_unlock_1(ptr);
+}
+
+# define protect_start_end 1
+# ifdef HAVE_ATTRIBUTE_VISIBILITY
+#  pragma GCC visibility pop
+# endif
+#endif /* protect_start_end */
+
+#include_next <host-config.h>
diff -ruN gcc-15.1.0.orig/libatomic/config/morphos/lock.c gcc-15.1.0/libatomic/config/morphos/lock.c
--- gcc-15.1.0.orig/libatomic/config/morphos/lock.c	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/libatomic/config/morphos/lock.c	2025-04-25 15:58:40.276619928 +0300
@@ -0,0 +1,178 @@
+/* Copyright (C) 2014-2019 Free Software Foundation, Inc.
+   Contributed by Kai Tietz <ktietz@redhat.com>.
+   Copyright (C) 2020 Harry Sintonen <sintonen@iki.fi>.
+
+   This file is part of the GNU Atomic Library (libatomic).
+
+   Libatomic is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   Libatomic is distributed in the hope that it will be useful, but WITHOUT ANY
+   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+   more details.
+
+   Under Section 7 of GPL version 3, you are granted additional
+   permissions described in the GCC Runtime Library Exception, version
+   3.1, as published by the Free Software Foundation.
+
+   You should have received a copy of the GNU General Public License and
+   a copy of the GCC Runtime Library Exception along with this program;
+   see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#define UWORD __shadow_UWORD
+#define __IXEMUL_EXEC_MIXING_ALLOWED
+#include <exec/semaphores.h>
+#include <proto/exec.h>
+#undef UWORD
+#ifdef __ixemul__
+# include <signal.h>
+#endif
+#include "libatomic_i.h"
+
+/* The target page size.  Must be no larger than the runtime page size,
+   lest locking fail with virtual address aliasing (i.e. a page mmaped
+   at two locations).  */
+#ifndef PAGE_SIZE
+#define PAGE_SIZE 4096
+#endif
+
+/* The target cacheline size.  This is an optimization; the padding that
+   should be applied to the locks to keep them from interfering.  */
+#ifndef CACHLINE_SIZE
+#define CACHLINE_SIZE 64
+#endif
+
+/* The granularity at which locks are applied.  Almost certainly the
+   cachline size is the right thing to use here.  */
+#ifndef WATCH_SIZE
+#define WATCH_SIZE CACHLINE_SIZE
+#endif
+
+struct lock
+{
+  struct SignalSemaphore sema;
+  char pad[sizeof (struct SignalSemaphore) < CACHLINE_SIZE
+	   ? CACHLINE_SIZE - sizeof (struct SignalSemaphore)
+	   : 0];
+};
+
+#define NLOCKS (PAGE_SIZE / WATCH_SIZE)
+
+static struct lock locks[NLOCKS];
+
+static inline uintptr_t
+addr_hash(void *ptr)
+{
+  return ((uintptr_t)ptr / WATCH_SIZE) % NLOCKS;
+}
+
+static inline int
+SemaphoreIsValid(const struct SignalSemaphore *sema)
+{
+  return sema->ss_Link.ln_Type == NT_SIGNALSEM;
+}
+
+void
+libat_lock_1(void *ptr)
+{
+  #ifdef __ixemul__
+  int omask = sigsetmask(~0);
+  #endif
+  Forbid();
+  if (!SemaphoreIsValid(&locks[addr_hash(ptr)].sema))
+    InitSemaphore(&locks[addr_hash(ptr)].sema);
+  Permit();
+  ObtainSemaphore(&locks[addr_hash(ptr)].sema);
+  #ifdef __ixemul__
+  sigsetmask(omask);
+  #endif
+}
+
+void
+libat_unlock_1(void *ptr)
+{
+  if (SemaphoreIsValid(&locks[addr_hash(ptr)].sema))
+  {
+    #ifdef __ixemul__
+    int omask = sigsetmask(~0);
+    #endif
+    ReleaseSemaphore(&locks[addr_hash(ptr)].sema);
+    #ifdef __ixemul__
+    sigsetmask(omask);
+    #endif
+  }
+}
+
+void
+libat_lock_n(void *ptr, size_t n)
+{
+  uintptr_t h = addr_hash(ptr);
+  size_t i = 0;
+  uintptr_t _h;
+  #ifdef __ixemul__
+  int omask = sigsetmask(~0);
+  #endif
+
+  /* Don't lock more than all the locks we have.  */
+  if (n > PAGE_SIZE)
+    n = PAGE_SIZE;
+
+  /* First initialize uninitialized semaphores */
+  Forbid();
+  _h = h;
+  do
+    {
+      if (!SemaphoreIsValid(&locks[_h].sema))
+	InitSemaphore(&locks[_h].sema);
+      if (++_h == NLOCKS)
+	_h = 0;
+      i += WATCH_SIZE;
+    }
+  while (i < n);
+  Permit();
+
+  i = 0;
+  do
+    {
+      ObtainSemaphore(&locks[h].sema);
+      if (++h == NLOCKS)
+	h = 0;
+      i += WATCH_SIZE;
+    }
+  while (i < n);
+
+  #ifdef __ixemul__
+  sigsetmask(omask);
+  #endif
+}
+
+void
+libat_unlock_n(void *ptr, size_t n)
+{
+  uintptr_t h = addr_hash(ptr);
+  size_t i = 0;
+  #ifdef __ixemul__
+  int omask = sigsetmask(~0);
+  #endif
+
+  if (n > PAGE_SIZE)
+    n = PAGE_SIZE;
+
+  do
+    {
+      if (SemaphoreIsValid(&locks[h].sema))
+	ReleaseSemaphore(&locks[h].sema);
+      if (++h == NLOCKS)
+	h = 0;
+      i += WATCH_SIZE;
+    }
+  while (i < n);
+
+  #ifdef __ixemul__
+  sigsetmask(omask);
+  #endif
+}
diff -ruN gcc-15.1.0.orig/libatomic/configure.tgt gcc-15.1.0/libatomic/configure.tgt
--- gcc-15.1.0.orig/libatomic/configure.tgt	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libatomic/configure.tgt	2025-04-25 15:58:40.276619928 +0300
@@ -168,6 +168,11 @@
         esac
 	;;
 
+  *-*-morphos*)
+	# OS support for atomic primitives.
+	config_path="${config_path} morphos"
+ 	;;
+
   *-*-rtems*)
 	XCFLAGS="${configure_tgt_pre_target_cpu_XCFLAGS}"
 	config_path="rtems"
diff -ruN gcc-15.1.0.orig/libcpp/files.cc gcc-15.1.0/libcpp/files.cc
--- gcc-15.1.0.orig/libcpp/files.cc	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libcpp/files.cc	2025-04-25 15:58:40.276619928 +0300
@@ -39,6 +39,10 @@
 # define STAT_SIZE_RELIABLE(ST) true
 #endif
 
+#ifndef O_CASE
+# define O_CASE 0
+#endif
+
 #ifdef __DJGPP__
 #include <io.h>
   /* For DJGPP redirected input is opened in text mode.  */
@@ -240,7 +244,7 @@
       set_stdin_to_binary_mode ();
     }
   else
-    file->fd = open (file->path, O_RDONLY | O_NOCTTY | O_BINARY, 0666);
+    file->fd = open (file->path, O_RDONLY | O_NOCTTY | O_BINARY | O_CASE, 0666);
 
   if (file->fd != -1)
     {
